#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"ppdgem.h"
#include	"colours.h"
#include	"vmcolour.h"
#include	<dos.h>

#ifndef SEEK_SET
#define SEEK_SET 0
#endif


static char buffer[256];
#ifdef DESKACC
static char ebuf[256];
#endif

int lstrncmp(LPBYTE s1, LPBYTE s2, int l)
{
	while (l > 0)
	{
		if (*s1 != *s2) return (*s1 - *s2);

		++s1;
		++s2;
		--l;
	}
	return 0;
}

int lstrlen(LPBYTE s)
{
	int l = 0;

	while (*s) 
	{
		++s;
		++l;
	}
	
	return l;
}

void lstrcpy(char *d, LPBYTE s)
{
	*d = *s;

	while (*s)
	{
		++s;
		++d;
		*d = *s;
	}
}


/* Can't use getenv() - it doesn't work in desk accessories */

char *env_get(char *s)
{
#ifdef DESKACC
	union REGS ir, or;
	LPLPTR pPSP;
	LPBYTE pENV;
	char match[80];
	int l;
	
	sprintf(match, "%s=", s);
	l = strlen(match);
	
	ir.h.ah = 0x51;	/* Get PSP */
	intdos(&ir, &or);

	pPSP = MK_FP(or.x.bx, 0x2C);
	pENV = (LPBYTE)(*pPSP);

	while (*pENV)
	{
		if (!lstrncmp(pENV, match, l))
		{
			lstrcpy(ebuf, pENV + l);
			return ebuf;
		}
		pENV += 1 + lstrlen(pENV);
	}
	return NULL;
#else
	return getenv(s);
#endif
}



WORD rsrc_alert(WORD btn, WORD id)
{
	LPVOID addr;

	rsrc_gaddr(R_STRING, id, &addr);
		
	return form_alert(btn, (LPBYTE)addr);
}



int NextInt(char **ptr)
{
	while ((**ptr) < '0' || (**ptr) > '9')
	{
		if (!(**ptr)) return -1;
		++(*ptr);
	}
	return atoi(*ptr);
}






void ReadColour(char *buf, int nSet, int nCol)
{
	COLDEF *def;

	if (nSet < 0 || nSet > 9)  return;
	if (nCol < 0 || nCol > 15) return;

	def = &def_col[16 * nSet + nCol];
	
	buf = strchr(buf, '=');	if (!buf) return;
	def->fg = NextInt(&buf);
	buf = strchr(buf, ','); if (!buf) return;
	def->bg = NextInt(&buf);
	buf = strchr(buf, ',');	if (!buf) return;
	def->fs = NextInt(&buf);
	buf = strchr(buf, ','); if (!buf) return;
	def->fi = NextInt(&buf);
}




int ReadInt(char *buf)
{
	buf = strchr(buf, '='); 
	if (!buf) return -1;

	return NextInt(&buf);
}




void rstrip(char *s)
{
	int l = strlen(s) - 1;

	while (l >= 0)
	{
		if (s[l] == '\t' || s[l] == ' ' || s[l] == '\n') s[l] = 0;
		else break;
		--l;
	}
}


void lstrip(char *s)
{
	char *d = s;

	while ((*s) == ' ' || (*s) == '\t')
	{
		++s;
	}
	while (*s)
	{
		*d++ = *s++;
	}
}


void lrstrip(char *s)
{
	lstrip(s);
	rstrip(s);
}




int IniFindSection(FILE *fp, char *s, FILE *ofp)
{
	int n = strlen(s);
	
	while (fgets(buffer, 255, fp) != NULL)
	{
		if (ofp) fputs(buffer, ofp);
		rstrip(buffer);
		if (!strncmp(buffer, s, n)) return 1;
	}
	return 0;
}



void IniLoadColours(FILE *fp)
{
	int NC = 0;
	char *buf, *buf2;

	maxcol = -1;
	curcol = -1;
	
	while (fgets(buffer, 255, fp) != NULL)
	{
		lrstrip(buffer);
		if (buffer[0] == '[') break;	/* End of section */

		if (!strncmp(buffer, "MaxColors", 9))    maxcol = ReadInt(buffer);
		if (!strncmp(buffer, "CurrentColor",12)) curcol = ReadInt(buffer);
		if (!strncmp(buffer, "ColorSet",  8))    
			{
			NC     = atoi(buffer + 8);

			if (NC < 0 || NC > 10) continue;
			buf = strchr(buffer, '=');
			if (!buf) continue;

			buf  = strchr(buf, '"');
			if (!buf) continue;
			++buf;
			buf2 = strchr(buf, '"');
			if (buf2) *buf2 = 0;
			strcpy(csid[NC], buf);
			}
		if (!strncmp(buffer, "Name",      4))    ReadColour(buffer, NC, 8);
		if (!strncmp(buffer, "Info",      4))    ReadColour(buffer, NC, 12);
		if (!strncmp(buffer, "Slctdname", 9))    ReadColour(buffer, NC, 14);
		if (!strncmp(buffer, "Desktop",   7))    ReadColour(buffer, NC, 10);
		if (!strncmp(buffer, "Slider",    6))    ReadColour(buffer, NC, 9);
		if (!strncmp(buffer, "Button",    6))    ReadColour(buffer, NC, 11);		
		if (!strncmp(buffer, "Alert",     5))    ReadColour(buffer, NC, 13);			
	}

}


void WriteColour(FILE *fp, int nSet, int nCol)
{
	COLDEF *def;
	char *title;

	switch(nCol)
	{
		case 8:  title = "Name";      break;
		case 9:  title = "Slider";    break;
		case 10: title = "Desktop";   break;
		case 11: title = "Button";    break;
		case 12: title = "Info";      break;
		case 13: title = "Alert";     break;
		case 14: title = "Slctdname"; break;
		default: title = "Element";   break;
	}
	
	def = def_col + 16 * nSet + nCol;

	fprintf(fp,"\t\t%s=\t%s%d,%d,\t%d,%d\n", title,
				((strlen(title) > 6) ? "" : "\t"), 
	            def->fg, def->bg, def->fs, def->fi);
}




void IniSaveColours(FILE *fp)
{
	int NS, NC; 

	fprintf(fp, "MaxColors=%d\n", maxcol);
	fprintf(fp, "CurrentColor=%d\n", curcol);
	for (NS = 0; NS < maxcol; NS++)
	{
		fprintf(fp, "ColorSet%d=\"%s\"\n", NS, csid[NS]);
		for (NC = 8; NC < 15; NC++) WriteColour(fp, NS, NC);
	}

}







int ReadINI(void)
{
	char *cfgdir;
	FILE *fp;

	cfgdir = env_get("DRDOSCFG");
	fp     = NULL;

	memset(def_col, 0, sizeof(def_col));
	if (cfgdir)
	{
		sprintf(buffer, "%s/ViewMAX.INI", cfgdir);
		fp = fopen(buffer, "r");
	}
	if (!fp) fp = fopen("ViewMAX.INI", "r");

	if (!fp)
	{
		rsrc_alert(1, NOINI);
		return -1;
	}

	if (IniFindSection(fp, "[Colors]", NULL))
	{
		IniLoadColours(fp);
	}
	else
	{
		rsrc_alert(1, NOSEC);
		return -1;		
	}
	fclose(fp);

	return 0;
}



int WriteINI(void)
{
	char *cfgdir;
	FILE *fp, *ofp;
	char ininame[160], tmpname[160];
	
	
	cfgdir = env_get("DRDOSCFG");
	fp     = NULL;

	if (cfgdir)
	{
		sprintf(ininame, "%s/ViewMAX.INI", cfgdir);
		sprintf(tmpname, "%s/ViewMAX.$$$", cfgdir);
		fp  = fopen(ininame, "r");
		ofp = fopen(tmpname, "w");
	}
	if (!fp) 
	{
		strcpy(ininame, "ViewMAX.INI");
		fp = fopen("ViewMAX.INI", "r");
	}
	if (!ofp)
	{
		strcpy(tmpname, "ViewMAX.$$$");
/* [JCE 27-12-2002] Oops. This will zap viewmax.ini */
		/* fp = fopen("ViewMAX.INI", "w"); */
		fp = fopen("ViewMAX.$$$", "w");
	}
	
	if (!fp)
	{
		rsrc_alert(1, NOINI);
		return -1;
	}
	if (!ofp)
	{
		fclose(fp);
		rsrc_alert(1, NOCREATE);
		return -1;
	}
	
	if (IniFindSection(fp, "[Colors]", ofp))
	{
		IniSaveColours(ofp);
		IniFindSection(fp, "[", NULL);	/* Skip previous "Colors" section */
		fprintf(ofp, "%s\n", buffer);	/* Write heading of next section */
		IniFindSection(fp, "[]", ofp);	/* Transcribe remainder of file */
	}
	else
	{
		rsrc_alert(1, NOSEC);
		return -1;		
	}
	fclose(fp);
	fclose(ofp);

	remove(ininame);
	rename(tmpname, ininame);
	
	return 0;
}

